'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _request = require('../request');

var _request2 = _interopRequireDefault(_request);

var _formSerialize = require('form-serialize');

var _formSerialize2 = _interopRequireDefault(_formSerialize);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
    bind: function bind() {

        switch (this.el.tagName.toLowerCase()) {

            case 'a':
                this.on('click', handleLinkClick.bind(this));
                break;

            case 'form':
                this.on('submit', handleFormSubmit.bind(this));
                break;

        }
    }
};


function handleFormSubmit(event) {
    var _this = this;

    event.preventDefault();

    var container = this.arg;
    var url = this.el.getAttribute('action');
    var method = this.el.getAttribute('method') || 'POST';
    var data = (0, _formSerialize2.default)(this.el);

    (0, _request2.default)(container, { url: url, method: method, data: data }).then(function (response) {
        _this.vm.$broadcast('pjax-loaded', {
            url: url,
            container: container,
            content: response.data
        });
    }, function () {
        window.location = url;
    });
}

function handleLinkClick(event) {
    var _this2 = this;

    event.preventDefault();

    var container = this.arg;
    var url = this.el.getAttribute('href');

    (0, _request2.default)(container, { url: url, method: 'GET' }).then(function (response) {
        _this2.vm.$broadcast('pjax-loaded', {
            url: url,
            container: container,
            content: response.data
        });
    }, function () {
        window.location = url;
    });
}